<?php

namespace Pcm\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for HoursOfServiceReport StructType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:HoursOfServiceReport
 * @package Pcm
 * @subpackage Structs
 */
class PcmHoursOfServiceReport extends PcmReport
{
    /**
     * The DriverHoursOfServiceRemaining
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \Pcm\StructType\PcmHoursOfServiceRemaining
     */
    public $DriverHoursOfServiceRemaining;
    /**
     * The Stops
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \Pcm\ArrayType\PcmArrayOfHoursOfServiceLocation
     */
    public $Stops;
    /**
     * The TotalDrivingDuration
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var float
     */
    public $TotalDrivingDuration;
    /**
     * The TotalDuration
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var float
     */
    public $TotalDuration;
    /**
     * Constructor method for HoursOfServiceReport
     * @uses PcmHoursOfServiceReport::setDriverHoursOfServiceRemaining()
     * @uses PcmHoursOfServiceReport::setStops()
     * @uses PcmHoursOfServiceReport::setTotalDrivingDuration()
     * @uses PcmHoursOfServiceReport::setTotalDuration()
     * @param \Pcm\StructType\PcmHoursOfServiceRemaining $driverHoursOfServiceRemaining
     * @param \Pcm\ArrayType\PcmArrayOfHoursOfServiceLocation $stops
     * @param float $totalDrivingDuration
     * @param float $totalDuration
     */
    public function __construct(\Pcm\StructType\PcmHoursOfServiceRemaining $driverHoursOfServiceRemaining = null, \Pcm\ArrayType\PcmArrayOfHoursOfServiceLocation $stops = null, $totalDrivingDuration = null, $totalDuration = null)
    {
        $this
            ->setDriverHoursOfServiceRemaining($driverHoursOfServiceRemaining)
            ->setStops($stops)
            ->setTotalDrivingDuration($totalDrivingDuration)
            ->setTotalDuration($totalDuration);
    }
    /**
     * Get DriverHoursOfServiceRemaining value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \Pcm\StructType\PcmHoursOfServiceRemaining|null
     */
    public function getDriverHoursOfServiceRemaining()
    {
        return isset($this->DriverHoursOfServiceRemaining) ? $this->DriverHoursOfServiceRemaining : null;
    }
    /**
     * Set DriverHoursOfServiceRemaining value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \Pcm\StructType\PcmHoursOfServiceRemaining $driverHoursOfServiceRemaining
     * @return \Pcm\StructType\PcmHoursOfServiceReport
     */
    public function setDriverHoursOfServiceRemaining(\Pcm\StructType\PcmHoursOfServiceRemaining $driverHoursOfServiceRemaining = null)
    {
        if (is_null($driverHoursOfServiceRemaining) || (is_array($driverHoursOfServiceRemaining) && empty($driverHoursOfServiceRemaining))) {
            unset($this->DriverHoursOfServiceRemaining);
        } else {
            $this->DriverHoursOfServiceRemaining = $driverHoursOfServiceRemaining;
        }
        return $this;
    }
    /**
     * Get Stops value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \Pcm\ArrayType\PcmArrayOfHoursOfServiceLocation|null
     */
    public function getStops()
    {
        return isset($this->Stops) ? $this->Stops : null;
    }
    /**
     * Set Stops value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \Pcm\ArrayType\PcmArrayOfHoursOfServiceLocation $stops
     * @return \Pcm\StructType\PcmHoursOfServiceReport
     */
    public function setStops(\Pcm\ArrayType\PcmArrayOfHoursOfServiceLocation $stops = null)
    {
        if (is_null($stops) || (is_array($stops) && empty($stops))) {
            unset($this->Stops);
        } else {
            $this->Stops = $stops;
        }
        return $this;
    }
    /**
     * Get TotalDrivingDuration value
     * @return float|null
     */
    public function getTotalDrivingDuration()
    {
        return $this->TotalDrivingDuration;
    }
    /**
     * Set TotalDrivingDuration value
     * @param float $totalDrivingDuration
     * @return \Pcm\StructType\PcmHoursOfServiceReport
     */
    public function setTotalDrivingDuration($totalDrivingDuration = null)
    {
        $this->TotalDrivingDuration = $totalDrivingDuration;
        return $this;
    }
    /**
     * Get TotalDuration value
     * @return float|null
     */
    public function getTotalDuration()
    {
        return $this->TotalDuration;
    }
    /**
     * Set TotalDuration value
     * @param float $totalDuration
     * @return \Pcm\StructType\PcmHoursOfServiceReport
     */
    public function setTotalDuration($totalDuration = null)
    {
        $this->TotalDuration = $totalDuration;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \Pcm\StructType\PcmHoursOfServiceReport
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
